import 'package:recase/recase.dart';

import '../interface/sample_interface.dart';

/// [Sample] file from provider file creation.
class MegaProviderSample extends Sample {
  final String _fileName;
  MegaProviderSample(String path, this._fileName, {bool overwrite = false})
      : super(path, overwrite: overwrite);

  @override
  String get content => flutterController;

  String get flutterController =>
      '''import 'package:mega_commons/mega_commons.dart';

class ${_fileName.pascalCase}Provider {
  final RestClientDio _restClientDio;

  ${_fileName.pascalCase}Provider({required RestClientDio restClientDio})
      : _restClientDio = restClientDio;

  Future<MegaResponse> onSubmitRequest() async {
    final response = await _restClientDio.get('');
    return response;
  }
}
''';
}
